import { EventEmitter, Component, ChangeDetectionStrategy, Input, Output, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/models/pagination-metadata.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PaginationMetadata = /** @class */ (function () {
    function PaginationMetadata(currentPage, totalPages, pageSize, totalCount, hasPrevious, hasNext) {
        if (currentPage === void 0) { currentPage = 1; }
        if (totalPages === void 0) { totalPages = 0; }
        if (pageSize === void 0) { pageSize = 25; }
        if (totalCount === void 0) { totalCount = 0; }
        if (hasPrevious === void 0) { hasPrevious = false; }
        if (hasNext === void 0) { hasNext = false; }
        this.currentPage = currentPage;
        this.totalPages = totalPages;
        this.pageSize = pageSize;
        this.totalCount = totalCount;
        this.hasPrevious = hasPrevious;
        this.hasNext = hasNext;
    }
    return PaginationMetadata;
}());
if (false) {
    /** @type {?} */
    PaginationMetadata.prototype.currentPage;
    /** @type {?} */
    PaginationMetadata.prototype.totalPages;
    /** @type {?} */
    PaginationMetadata.prototype.pageSize;
    /** @type {?} */
    PaginationMetadata.prototype.totalCount;
    /** @type {?} */
    PaginationMetadata.prototype.hasPrevious;
    /** @type {?} */
    PaginationMetadata.prototype.hasNext;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/pager.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PagerComponent = /** @class */ (function () {
    function PagerComponent() {
        this.floatRight = false;
        this.resultsHeader = 'Total Results:';
        this.pageSizes = [5, 10, 25, 50, 100];
        this.pagerChanged = new EventEmitter();
    }
    /**
     * @param {?} page
     * @return {?}
     */
    PagerComponent.prototype.onPageChanged = /**
     * @param {?} page
     * @return {?}
     */
    function (page) {
        if (page !== this.pageinationMetaData.currentPage) {
            this.pageinationMetaData.currentPage = page;
            this.pagerChanged.emit();
        }
    };
    /**
     * @param {?} pageSize
     * @return {?}
     */
    PagerComponent.prototype.onPageSizeChanged = /**
     * @param {?} pageSize
     * @return {?}
     */
    function (pageSize) {
        if (pageSize !== this.pageinationMetaData.pageSize) {
            this.pageinationMetaData.currentPage = 1;
            this.pageinationMetaData.pageSize = pageSize;
            this.pagerChanged.emit();
        }
    };
    PagerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngc-pager',
                    template: "<section *ngIf=\"pageinationMetaData\" [ngClass]=\"[floatRight ? 'float-right' : 'float-left', 'site-pager']\">\r\n    <div class=\"row mb-3\">\r\n        <div class=\"col-md-12\">\r\n            <span class=\"pager-form-control\">\r\n                <label class=\"mr-2\">{{resultsHeader}} {{pageinationMetaData.totalCount}}</label>\r\n            </span>\r\n            <button *ngIf=\"pageinationMetaData.hasPrevious\"\r\n                class=\"btn btn-sm btn-outline-primary mr-2 pager-form-control btnPreviousPage\" type=\"button\"\r\n                (click)=\"onPageChanged(pageinationMetaData.currentPage - 1)\"><i class=\"fa fa-arrow-left mr-1\"\r\n                    aria-hidden=\"true\"></i>Previous</button>\r\n            <button *ngIf=\"pageinationMetaData.hasNext\"\r\n                class=\"btn btn-sm btn-outline-primary mr-2 pager-form-control btnNextPage\" type=\"button\"\r\n                (click)=\"onPageChanged(pageinationMetaData.currentPage + 1)\">Next<i class=\"fa fa-arrow-right ml-1\"\r\n                    aria-hidden=\"true\"></i></button>\r\n            <span class=\"pager-form-control\">\r\n                <span *ngIf=\"pageinationMetaData && pageinationMetaData.totalPages > 1\">\r\n                    <label class=\"mr-1\">Page: </label>\r\n                    <select class=\"form-control form-control-sm mr-2\" (change)=\"onPageChanged($event.target.value)\">\r\n                        <option *ngFor=\"let item of [].constructor(pageinationMetaData.totalPages); let i = index;\"\r\n                            [selected]=\"i + 1 === pageinationMetaData.currentPage\" [value]=\"i + 1\">{{i + 1}}</option>\r\n                    </select>\r\n                </span>\r\n                <label class=\"mr-1\">Showing: </label>\r\n                <select class=\"form-control form-control-sm mr-2\" (change)=\"onPageSizeChanged($event.target.value)\">\r\n                    <option *ngFor=\"let pageSize of pageSizes\" [value]=\"pageSize\" [selected]=\"pageinationMetaData.pageSize === pageSize\">{{pageSize}}</option>\r\n                </select>\r\n            </span>\r\n        </div>\r\n    </div>\r\n</section>",
                    changeDetection: ChangeDetectionStrategy.OnPush,
                    styles: [".page-link:active,.page-link:focus,.page-link:hover{cursor:pointer}li.active .page-link:active,li.active .page-link:focus,li.active .page-link:hover{cursor:default;color:#fff}.site-pager select{width:70px;display:inline}@media (max-width:575px){.pager-form-control{width:100%;display:block;text-align:center;margin-bottom:5px}.site-pager{float:none!important}.pager-form-control label{margin-bottom:0}}"]
                }] }
    ];
    /** @nocollapse */
    PagerComponent.ctorParameters = function () { return []; };
    PagerComponent.propDecorators = {
        pageinationMetaData: [{ type: Input }],
        floatRight: [{ type: Input }],
        resultsHeader: [{ type: Input }],
        pageSizes: [{ type: Input }],
        pagerChanged: [{ type: Output }]
    };
    return PagerComponent;
}());
if (false) {
    /** @type {?} */
    PagerComponent.prototype.pageinationMetaData;
    /** @type {?} */
    PagerComponent.prototype.floatRight;
    /** @type {?} */
    PagerComponent.prototype.resultsHeader;
    /** @type {?} */
    PagerComponent.prototype.pageSizes;
    /** @type {?} */
    PagerComponent.prototype.pagerChanged;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/pager.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var PagerModule = /** @class */ (function () {
    function PagerModule() {
    }
    PagerModule.decorators = [
        { type: NgModule, args: [{
                    imports: [CommonModule],
                    declarations: [PagerComponent],
                    exports: [PagerComponent]
                },] }
    ];
    return PagerModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: ngc-pager.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { PagerComponent, PagerModule, PaginationMetadata };
//# sourceMappingURL=ngc-pager.js.map
